---
title: ImageCapture.getPhotoSettings()
slug: Web/API/ImageCapture/getPhotoSettings
tags:
  - API
  - Experimental
  - Image
  - Image Capture
  - ImageCapture
  - Media
  - MediaStream Image Capture API
  - Method
  - Reference
  - getPhotoSettings
---
<div>{{APIRef("MediaStream Image")}}</div>

<p><span class="seoSummary">The <strong><code>getPhotoSettings()</code></strong> method of the {{domxref("ImageCapture")}} interface returns a {{jsxref("Promise")}} that resolves with a {{domxref("PhotoSettings")}} object containing the current photo configuration settings.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>settingsPromise</em> = <em>imageCapture</em>.getPhotoSettings()</pre>

<h3 id="Return_value"><span style='font-family: x-locale-heading-primary,zillaslab,Palatino,"Palatino Linotype",x-locale-heading-secondary,serif; font-size: 1.375rem;'>Return value</span></h3>

<p>A {{jsxref("Promise")}} that resolves with a {{domxref("PhotoSettings")}} object containing the following properties:</p>

<ul>
 <li><code>fillLightMode</code>:  The flash setting of the capture device, one of <code>"auto"</code>, <code>"off"</code>, or <code>"on"</code>.</li>
 <li><code>imageHeight</code>: The desired image height as an integer. The user agent selects the closest width value to this setting if it only supports discrete heights.</li>
 <li><code>imageWidth</code>: The desired image width as an integer. The user agent selects the closest width value to this setting if it only supports discrete widths.</li>
 <li><code>redEyeReduction</code>: A boolean indicating whether the red-eye reduction should be used if it is available.</li>
</ul>

<h2 id="Example">Example</h2>

<p>The following example, extracted from <a href="https://googlechrome.github.io/samples/image-capture/photo-resolution.html">Chrome's Image Capture / Photo Resolution Sample</a>, uses the results from <code>getPhotoSettings()</code> to modify the size of an input range. This example also shows how the {{domxref("ImageCapture")}} object is created using a {{domxref("MediaStreamTrack")}} retrieved from a device's {{domxref("MediaStream")}}.</p>

<pre class="brush: js"><code>const input = document.querySelector('input[type="range"]');

var imageCapture;

navigator.mediaDevices.getUserMedia({video: true})
.then(mediaStream =&gt; {
  document.querySelector('video').srcObject = mediaStream;

  const track = mediaStream.getVideoTracks()[0];
  imageCapture = new ImageCapture(track);

  return imageCapture.getPhotoCapabilities();
})
.then(photoCapabilities =&gt; {
  const settings = imageCapture.track.getSettings();

  input.min = photoCapabilities.imageWidth.min;
  input.max = photoCapabilities.imageWidth.max;
  input.step = photoCapabilities.imageWidth.step;

  return imageCapture.getPhotoSettings();
})
.then(photoSettings =&gt; {
  input.value = photoSettings.imageWidth;
})
.catch(error =&gt; console.log('Argh!', error.name || error));</code></pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('MediaStream Image','#dom-imagecapture-getphotosettings','getPhotoSettings()')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ImageCapture.getPhotoSettings")}}</p>
</div>
